/* EPITA - IP - S3/4 */
/* question08 */

#define QNUM 8
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question08.h"

static
struct list* build_list(size_t len, struct list store[]) {
  struct list *cur;
  for (cur = store; len > 0; len--) {
    cur->next = cur + 1;
    cur += 1;
  }
  cur->next = NULL;
  return store;
}

static
void fixed_test(size_t len) {
  printf("Fixed tests:\n");
  struct list *store, *list;
  store = calloc(len + 2, sizeof (struct list));
  list = build_list(len, store);
  size_t res_len = list_len(list);
  printf("  list_len(list) = %zu \t[%s]\n", res_len, check(res_len == len));
  free(store);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
    }
  exit(0);
}
