/* EPITA - IP - S3/4 */
/* question17 */

#define QNUM 17
#define QOPT "command args..."
#define QNOPT 1

# include <assert.h>
# include <err.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question17.h"


int main(int argc,char *argv[])
{
  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      char *cmd = argv[1];
      char **args = argv + 1;
      struct status status = {0, 0, 0};
      get_status(cmd, args, &status);
      printf("Command %s exited normaly: %s\n", cmd, check(status.exited));
      if (status.exited)
	printf("  exit status: %d\n", status.exit_status);
      else
	printf("  killed by signal: %d\n", status.kill_signal);
    }
  exit(0);
}
